#
#	SS.make	- Makefile for SS
#
#	Copyright  1989, Claris Corporation.
#
#	This is a sub-makefile, called recursively when ::AppleWorks.make is
#	executed.
#
#	All modules (including Driver, Scrap, Pict., SS, DB, etc.)
#	should have similar makefiles in their respective folders.
#
#	This makefile rebuilds the module object files as necessary and creates a
#	file containing the necessary steps to link this module with the rest of 
#	AppleWorksGS.  ::AppleWorks.make combines the link files from the modules
#	into a script which it executes to create an executable.

#--------------------------------------------------------------------------------
#	Variables

AsmIIGSOptions	=	-i {IncDir},{AWGS}Macros,{AWGS}Driver,{AWGS}Heap,{AWGS}Eval

#				-d Profile,ProfileNumber=13

Segment1		=	SS
Segment2		=	SS2

Module		=	SS
ModuleDir		=	{AWGS}{Module}:

SrcDir 		=	{ModuleDir}Src:
IncDir 		=	{ModuleDir}
ObjDir 		=	{ModuleDir}Obj:

Linkfile		=	{ModuleDir}{Module}.link
Makefile		=	{ModuleDir}{Module}.make

GlobalIncludes	=	{IncDir}SS.equ			
				{AWGS}Driver:Driver.equ	
				{AWGS}Heap:Heap.aii.i

GlobalMacros	=	{AWGS}Macros:Macros.dump	
				{AWGS}Macros:M16.Profile	

Objs			=	{Objs1} {Objs2}

Objs1		=	{ObjDir}Data.aii.o		
				{ObjDir}SS.aii.o		
				{ObjDir}FileIO.aii.o	
				{ObjDir}Edit.aii.o		
				{ObjDir}Edit2.aii.o		
				{ObjDir}Undo.aii.o		
				{ObjDir}Move.aii.o		
				{ObjDir}Move2.aii.o		
				{ObjDir}Move3.aii.o		
				{ObjDir}Sort.aii.o		
				{ObjDir}Format.aii.o	
				{ObjDir}Options.aii.o	
				{ObjDir}DataMenu.aii.o	
				{ObjDir}Update.aii.o	
				{ObjDir}Draw.aii.o		
				{ObjDir}Draw2.aii.o		
				{ObjDir}Mouse.aii.o		
				{ObjDir}Key.aii.o		
				{ObjDir}Misc.aii.o		
				{ObjDir}Cells.aii.o		
				{ObjDir}Cells2.aii.o	
				{ObjDir}CellEdit.aii.o	
				{ObjDir}CellEval.aii.o	
				{ObjDir}Eval2.aii.o		
				{ObjDir}Dlog.aii.o

Objs2		=	{ObjDir}Misc2.aii.o			
				{ObjDir}Dlog2.aii.o			
				{ObjDir}Chart.aii.o			
				{ObjDir}Pie.aii.o			
				{ObjDir}Bar.aii.o			
				{ObjDir}ChartData.aii.o


#--------------------------------------------------------------------------------
#	Main target

{Linkfile}		{Objs} {Makefile}
	@if "`newer {Makefile} {LinkFile}`"
		@echo	"Creating {LinkFile} "
		@echo	"	-lseg{Kind}		{Segment1}	{Objs1}	" >  {Targ}
		@echo	"	-lseg{Kind}		{Segment2}	{Objs2}	" >> {Targ}
	@else
		@touch {Linkfile}
	@end


#	SS dependencies

{Objs}						{GlobalIncludes} {GlobalMacros}

{ObjDir}Data.aii.o			
{ObjDir}CellEdit.aii.o		
{ObjDir}CellEval.aii.o		
{ObjDir}Cells2.aii.o		
{ObjDir}Move.aii.o			
{ObjDir}Move2.aii.o			
{ObjDir}Move3.aii.o			
{ObjDir}Undo.aii.o			
{ObjDir}SS.aii.o				{Makefile}

{ObjDir}CellEval.aii.o		
{ObjDir}CellEdit.aii.o		
{ObjDir}Cells2.aii.o		
{ObjDir}Dlog2.aii.o			
{ObjDir}Draw.aii.o			
{ObjDir}Edit.aii.o			
{ObjDir}Eval2.aii.o			
{ObjDir}Misc.aii.o			
{ObjDir}Misc2.aii.o			
{ObjDir}Move.aii.o			
{ObjDir}Move2.aii.o			
{ObjDir}Move3.aii.o			
{ObjDir}SS.aii.o				{AWGS}Eval:Eval.aii.i

clean	
	@confirm "Delete {Module} objs and linkfile?"
	@if {status} == 0 then
		rm	{Linkfile} {Objs}
	@end

#--------------------------------------------------------------------------------
#	Default rules

.aii.o		.aii
	AsmIIGS {DepDir}{Default}.aii -o {TargDir}{Default}.aii.o {AsmIIGSOptions}

{ObjDir}		{SrcDir}

